/* yasep/doc/docs.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mer. sept. 14 22:22:46 CEST 2011
A generic documentation page loader
 */

init_obj.push(DOC_GEN={
  win: null, // important : stores the ygwm id of the open window.

  valid_keys:{ // The keys that are handled by this routine
    "multiply":{titles:["Multiply",
                        "Multiplications"]},
    "reg-mem":{titles:["Registers and memory",
                       "Registres et mémoire"],
      onLoad:function(cont,h){
          // Generate the register map
          var i,t='<center><table style="font-family: monospace">',
              r=getById("regtable","DIV",cont);
          if (r) {
            for (i in Y.registers_names)
              t+='<tr style="background-color:#'+(i&1?'EEE':'FFF')+'"><td>#'
                  +i+':</td><td class="'+Y.registers_names[i][0]+'">&nbsp;<a href="#'
                  +Y.registers_names[i]+'">'+Y.registers_names[i]+"</a>&nbsp;</td></tr>";
            r.innerHTML=t+"</table></center>";
          }
        }
    }
  },

  autoindex:function(cont, key) {
    var i,a="",b,c=0,h,t="Index :<br>",
        d=getByClass("autoindex","DIV",cont);
    if (d) {
      i=cont.firstChild;
      // scan the first level of the DOM tree of the window
      while(i) {
        if ((i.nodeName[0]=="H")
         && (i.nodeName[1]!="1")) {
          if (a==""){
            a=key+"_"+c++;
            b=document.createElement("A");
            b.name=a;
            cont.insertBefore(b,i);
          }
          for (h=+i.nodeName[1]; h>0; h--)
            t+="&nbsp; ";
          t+='<a href="#'+a+'">'+i.innerHTML+"</a><br>";
          a="";
        }
        else
          if (i.nodeName=="A") {
            a=i.name;
// if debug:
//           t+="&lt;a name="+a+"> ";
          }
        i=i.nextSibling;
      }
      d.innerHTML=t;
    }
  },

// This function creates, displays and populates/updates the ygwm window
  start: function(key) {
    if (key.indexOf("doc/")!=0)
      return null;
    key=key.slice(4);
    if (!(DOC_GEN.valid_keys[key]))
      return null;
    cont=document.createElement("DIV");
    DOC_GEN.cont=cont;

    cont.innerHTML=import_htmi("doc/"+key);

    winman.patchInnerLinks(cont);
    // get the hidden DIV where language-specific snippets are stored
    var h=getByClass("hiddenDiv","DIV",cont);
    DOC_GEN.win = ygwm.new_window(
       hiddenText(0,h), null, cont,
       500, 400, 250, 250, false, true, true, true, false, "doc_cyan");

    // run an eventual page-specific routine
    var f=DOC_GEN.valid_keys[key].onLoad;
    if (typeof f == "function")
      f(cont,h);

    DOC_GEN.autoindex(cont,key);
    return DOC_GEN.win;
  },

  init_obj: function(){
    for (var key in DOC_GEN.valid_keys) {
      winman.register_key("doc/"+key,DOC_GEN.start);
      menu.subMenuItem(menu.list["Doc"], DOC_GEN.valid_keys[key].titles, "doc/"+key);
    }
  }
});
