/* yasep/ASM/importASM.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created lun. févr. 13 04:59:42 CET 2012 by whygee@f-cpu.org
version lun. avril 16 02:25:12 CEST 2012 : file import(s)

Purpose : import data from copy/paste, keyboard, another window, or a file (?)
 and create a YASMed window

Missing : file import
 */

init_obj.push(impASM={
  win: null,

  edit_id: null,

  // load from a file, possibly from the user, through the loopback
  importFile: function(name) {
    var s=name; // add loopback function here
    if (s)
      impASM.importCode(s);
  },

  // This is a version that deals only with "internal" files from the site
  trigger: function(s) {
    if (s!=""){
      var c=config.win;
      impASM.win.hide_all();
      s=import_data(s);
      if(typeof s=="string")
        impASM.importCode(s);
      if(config.win && !c)
        config.win.hide_all();
    }
  },

  importCode: function(s) {
    // create the window
    var w=YASMed.start(), i;
    if (typeof s!=="string" && impASM.win)
      s=impASM.edit_id.value;
    s=s.split('\n');
    // move the contents there
    for (i in s) 
      YASMed.NewLine(w,s[i]);
    YASMed.AdjustPClen(w);
    return w; // for later resize by YASMED.js
  },

  start: function() {
    impASM.cont=document.createElement("DIV");
    impASM.cont.innerHTML=import_htmi("ASM/importASM");
    var h=getByClass("hiddenDiv","DIV",impASM.cont);
    impASM.win = ygwm.new_window(
       hiddenText(0,h), null, impASM.cont,
       450, 450, 50, 50, false, true, true, true, false, "WinOK");

    getById("importASM","button",impASM.cont).onclick=impASM.importCode;
    impASM.edit_id=getById("importArea","textarea",impASM.cont);
    impASM.win.trigger=impASM.trigger;
    return impASM.win;
  },

  init_obj: function(){
    impASM.menuItem = menu.subMenuItem(menu.list["ASM"],["Import","Importer"], "ASM/impASM");
  }
});
