/* DeforaOS/Apps/Devel/src/asm/test/yasep.S
   Copyright (c) 2011 Pierre Pronchery <khorben@defora.org>
   Copyright (c) 2011-2012 Yann Guidon <whygee@f-cpu.org>
   This file is part of DeforaOS Devel asm

   Assembly language dump to test the Defora
    assembler for the YASEP architecture.
   Bytes are in little endian order.

   Generated on Mon, 13 Aug 2012 13:42:11 GMT
   by http://127.0.0.1/~yg/index.dev.html
      yasep/defora/gen_asm.js revision 2012/08/13
 */

.text
/* 0x14 = ADD : Addition*/
	add r5 d2               /* FORM_RR     0x14 0x5C               */
	add r5 d2 lsb1 d3       /* FORM_RR     0x17 0x5C 0x80 0xAC     */
	add 6 a5                /* FORM_iR     0x16 0x67               */
	add 6 a5 lsb1 d4        /* FORM_iR     0x17 0x67 0x82 0x87     */
	add 18317 a3 r2         /* FORM_IRR    0x15 0x2B 0x8D 0x47     */
	add 31734 d2            /* FORM_IR     0x15 0xCC 0xF6 0x7B     */
	add pc a2 d5            /* FORM_RRR    0x17 0x0D 0x00 0x06     */
	add pc a2 d5 msb0 r4    /* FORM_RRR    0x17 0x0D 0xE0 0x46     */
	add 6 a4 a2             /* FORM_iRR    0x17 0x69 0x02 0x0D     */
	add 6 a4 a2 no_carry    /* FORM_iRR    0x17 0x69 0xA2 0x0D     */

/* 0x10 = AND : Boolean AND*/
	and d3 r5               /* FORM_RR     0x10 0xA5               */
	and d3 r5 nz d2         /* FORM_RR     0x13 0xA5 0x20 0xC5     */
	and 6 a5                /* FORM_iR     0x12 0x67               */
	and 6 a5 neq            /* FORM_iR     0x13 0x67 0xE2 0x07     */
	and 23080 r4 a2         /* FORM_IRR    0x11 0xD4 0x28 0x5A     */
	and 20161 d2            /* FORM_IR     0x11 0xCC 0xC1 0x4E     */
	and d2 d4 a2            /* FORM_RRR    0x13 0xC8 0x00 0x0D     */
	and d2 d4 a2 neq        /* FORM_RRR    0x13 0xC8 0xE0 0x0D     */
	and 7 r3 a3             /* FORM_iRR    0x13 0x73 0x02 0x0B     */
	and 7 r3 a3 msb1 a5     /* FORM_iRR    0x13 0x73 0xC2 0x7B     */

/* 0x30 = ANDN : Boolean AND with one negated input*/
	andn r5 d1              /* FORM_RR     0x30 0x5E               */
	andn r5 d1 bit0 1       /* FORM_RR     0x33 0x5E 0x60 0x1E     */
	andn 6 d3               /* FORM_iR     0x32 0x6A               */
	andn 6 d3 eq            /* FORM_iR     0x33 0x6A 0xC2 0x0A     */
	andn 15955 r5 r3        /* FORM_IRR    0x31 0x35 0x53 0x3E     */
	andn 4048 r3            /* FORM_IR     0x31 0x33 0xD0 0x0F     */
	andn r3 d1 a5           /* FORM_RRR    0x33 0x3E 0x00 0x07     */
	andn r3 d1 a5 lsb1 d3   /* FORM_RRR    0x33 0x3E 0x80 0xA7     */
	andn 2 r4 pc            /* FORM_iRR    0x33 0x24 0x02 0x00     */
	andn 2 r4 pc neq        /* FORM_iRR    0x33 0x24 0xE2 0x00     */

/* 0xC0 = CALL : Jump to SI4/IMM16/IMM20 (R/I/i) and write the NPC to SND*/
	call d3 d2              /* FORM_RR     0xC0 0xAC               */
	call d3 d2 lsb0 a5      /* FORM_RR     0xC3 0xAC 0xA0 0x7C     */
	call 2 r2               /* FORM_iR     0xC2 0x22               */
	call 2 r2 lsb0 r2       /* FORM_iR     0xC3 0x22 0xA2 0x22     */
	call 440447 r2          /* FORM_IR     0xC1 0x26 0x7F 0xB8     */

/* 0xE0 = CALL2 : Jump to SND+(SI4/IMM16) and write the NPC to SND/DST3*/
	call2 7022 pc r4        /* FORM_IRR    0xE1 0x40 0x6E 0x1B     */
	call2 d3 r5 r2          /* FORM_RRR    0xE3 0xA5 0x00 0x02     */
	call2 d3 r5 r2 neq      /* FORM_RRR    0xE3 0xA5 0xE0 0x02     */
	call2 1 a2 r4           /* FORM_iRR    0xE3 0x1D 0x02 0x04     */
	call2 1 a2 r4 nz r1     /* FORM_iRR    0xE3 0x1D 0x22 0x14     */

/* 0x74 = CMPS : signed substract the 2 operands and set the Carry bit if borrow*/
	cmps a5 d3              /* FORM_RR     0x74 0x7A               */
	cmps a5 d3 bit1 1       /* FORM_RR     0x77 0x7A 0x40 0x1A     */
	cmps 2 r1               /* FORM_iR     0x76 0x21               */
	cmps 2 r1 msb1 r1       /* FORM_iR     0x77 0x21 0xC2 0x11     */
	cmps 29793 r2           /* FORM_IR     0x75 0x02 0x61 0x74     */

/* 0x54 = CMPU : unsigned substract the 2 operands and set the Carry bit if borrow*/
	cmpu d3 a1              /* FORM_RR     0x54 0xAF               */
	cmpu d3 a1 lsb0 r4      /* FORM_RR     0x57 0xAF 0xA0 0x4F     */
	cmpu 2 a4               /* FORM_iR     0x56 0x29               */
	cmpu 2 a4 bit1 0        /* FORM_iR     0x57 0x29 0x42 0x09     */
	cmpu 2354 d5            /* FORM_IR     0x55 0x06 0x32 0x09     */

/* 0x78 = CRC : combine source register with operand's CRC (1 byte in, 2 or 4 bytes out)*/
	crc d3 r1               /* FORM_RR     0x78 0xA1               */
	crc d3 r1 lsb0 a3       /* FORM_RR     0x7B 0xA1 0xA0 0xB1     */
	crc 4 r1                /* FORM_iR     0x7A 0x41               */
	crc 4 r1 nz d2          /* FORM_iR     0x7B 0x41 0x22 0xC1     */
	crc 61 a1 d1            /* FORM_IRR    0x79 0xEF 0x3D 0x00     */
	crc 149 pc              /* FORM_IR     0x79 0x00 0x95 0x00     */
	crc r2 d4 a5            /* FORM_RRR    0x7B 0x28 0x00 0x07     */
	crc r2 d4 a5 msb0 a2    /* FORM_RRR    0x7B 0x28 0xE0 0xD7     */
	crc 7 r1 r4             /* FORM_iRR    0x7B 0x71 0x02 0x04     */
	crc 7 r1 r4 bit0 5      /* FORM_iRR    0x7B 0x71 0x62 0x54     */

/* 0x20 = CRIT : Start a CRITical section: disable IRQs for imm4 instructions*/
	crit 7                  /* FORM_i      0x22 0x70               */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x68 = ESB (alias to LSB) : Extract and Sign-extend Byte*/
	esb d2 d5               /* FORM_RR     0x68 0xC6               */
	esb d2 d5 nz a1         /* FORM_RR     0x6B 0xC6 0x20 0xF6     */
#endif

#if defined(ARCH_yasep32)
#if defined(ALLOW_YASEP_ALIASES)
/* 0xE8 = ESH (alias to LSH) : Extract and Sign-extend Half-word*/
	esh d5 r1               /* FORM_RR     0xE8 0x61               */
	esh d5 r1 lsb1 a5       /* FORM_RR     0xEB 0x61 0x80 0x71     */
#endif
#endif

#if defined(ALLOW_YASEP_ALIASES)
/* 0x48 = EZB (alias to LZB) : Extract and Zero-extend Byte*/
	ezb d4 d1               /* FORM_RR     0x48 0x8E               */
	ezb d4 d1 neq           /* FORM_RR     0x4B 0x8E 0xE0 0x0E     */
#endif

#if defined(ARCH_yasep32)
#if defined(ALLOW_YASEP_ALIASES)
/* 0xC8 = EZH (alias to LZH) : Extract and Zero-extend Half-word*/
	ezh d3 d4               /* FORM_RR     0xC8 0xA8               */
	ezh d3 d4 msb1 a2       /* FORM_RR     0xCB 0xA8 0xC0 0xD8     */
#endif
#endif

/* 0x40 = GET : Read from the Special Registers space*/
	get d4 d3               /* FORM_RR     0x40 0x8A               */
	get d4 d3 lsb0 r4       /* FORM_RR     0x43 0x8A 0xA0 0x4A     */
	get 3 r3                /* FORM_iR     0x42 0x33               */
	get 3 r3 no_carry       /* FORM_iR     0x43 0x33 0xA2 0x03     */
	get 34738 r2            /* FORM_IR     0x41 0x20 0xB2 0x87     */

/* 0x04 = HALT : Stop the core and wait for an interrupt*/
	halt                    /* FORM_ALONE  0x04 0x00               */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x28 = IB (alias to SB) : Insert a byte into a (half)word*/
	ib a3 d2                /* FORM_RR     0x28 0xBC               */
	ib a3 d2 lsb0 r2        /* FORM_RR     0x2B 0xBC 0xA0 0x2C     */
	ib 1 r3                 /* FORM_iR     0x2A 0x13               */
	ib 1 r3 zero a2         /* FORM_iR     0x2B 0x13 0x02 0xD3     */
	ib 180 d3               /* FORM_IR     0x29 0xAA 0xB4 0x00     */
	ib a1 pc a3             /* FORM_RRR    0x2B 0xF0 0x00 0x0B     */
	ib a1 pc a3 lsb1 a1     /* FORM_RRR    0x2B 0xF0 0x80 0xFB     */
	ib 4 d4 a2              /* FORM_iRR    0x2B 0x48 0x02 0x0D     */
	ib 4 d4 a2 zero d4      /* FORM_iRR    0x2B 0x48 0x02 0x8D     */
#endif

#if defined(ARCH_yasep32)
#if defined(ALLOW_YASEP_ALIASES)
/* 0x88 = IH (alias to SH) : Insert the imm16/si4 Half-word*/
	ih r2 r3                /* FORM_RR     0x88 0x23               */
	ih r2 r3 msb1 d4        /* FORM_RR     0x8B 0x23 0xC0 0x83     */
	ih 10754 pc             /* FORM_IR     0x89 0x00 0x02 0x2A     */
	ih d5 a4 r1             /* FORM_RRR    0x8B 0x69 0x00 0x01     */
	ih d5 a4 r1 nz d2       /* FORM_RRR    0x8B 0x69 0x20 0xC1     */
	ih 1 d3 d1              /* FORM_iRR    0x8B 0x1A 0x02 0x0E     */
	ih 1 d3 d1 nz r2        /* FORM_iRR    0x8B 0x1A 0x22 0x2E     */
#endif
#endif

#if defined(ARCH_yasep32)
#if defined(ALLOW_YASEP_ALIASES)
/* 0xA8 = IHH (alias to SHH) : Insert the imm16/si4 Half-word High*/
	ihh d5 a3               /* FORM_RR     0xA8 0x6B               */
	ihh d5 a3 lsb0 d5       /* FORM_RR     0xAB 0x6B 0xA0 0x6B     */
	ihh 3 pc                /* FORM_iR     0xAA 0x30               */
	ihh 3 pc carry          /* FORM_iR     0xAB 0x30 0x82 0x00     */
	ihh 2114 d3 r4          /* FORM_IRR    0xA9 0x4A 0x42 0x08     */
	ihh 3375 r2             /* FORM_IR     0xA9 0x22 0x2F 0x0D     */
	ihh a1 d5 r1            /* FORM_RRR    0xAB 0xF6 0x00 0x01     */
	ihh a1 d5 r1 nz d5      /* FORM_RRR    0xAB 0xF6 0x20 0x61     */
	ihh 7 a5 r2             /* FORM_iRR    0xAB 0x77 0x02 0x02     */
	ihh 7 a5 r2 msb1 r3     /* FORM_iRR    0xAB 0x77 0xC2 0x32     */
#endif
#endif

/* 0x80 = IN : Read data from I/O on data bus*/
	in r4 d5                /* FORM_RR     0x80 0x46               */
	in r4 d5 never          /* FORM_RR     0x83 0x46 0x20 0x06     */
	in r4 5                 /* FORM_Ri     0x82 0x54               */
	in r4 5 msb0 d2         /* FORM_Ri     0x83 0x54 0xE2 0xC0     */
	in d3 13472             /* FORM_RI     0x81 0x0A 0xA0 0x34     */

/* 0xFC = INV : Forbidden (invalid) opcode*/
	inv                     /* FORM_ALONE  0xFC 0x00               */

/* 0x24 = IPC : InterProcess Call*/
	ipc r3 r1               /* FORM_RR     0x24 0x31               */
	ipc r1 4                /* FORM_Ri     0x26 0x41               */
	ipc a5 5438             /* FORM_RI     0x25 0x07 0x3E 0x15     */

/* 0x44 = IPE : InterProcess Entry*/
	ipe d2 r3               /* FORM_RR     0x44 0xC3               */
	ipe r5 2                /* FORM_Ri     0x46 0x25               */
	ipe r2 24543            /* FORM_RI     0x45 0x02 0xDF 0x5F     */

/* 0x64 = IPR : InterProcess Return*/
	ipr a1 r5               /* FORM_RR     0x64 0xF5               */
	ipr r4 7                /* FORM_Ri     0x66 0x74               */
	ipr a1 2583             /* FORM_RI     0x65 0x0F 0x17 0x0A     */

/* 0x68 = LSB : Load and Sign-extend Byte*/
	lsb d5 a4               /* FORM_RR     0x68 0x69               */
	lsb d5 a4 lsb1 a5       /* FORM_RR     0x6B 0x69 0x80 0x79     */

#if defined(ARCH_yasep32)
/* 0xE8 = LSH : Load and Sign-extend Half-word*/
	lsh r5 a3               /* FORM_RR     0xE8 0x5B               */
	lsh r5 a3 bit1 10       /* FORM_RR     0xEB 0x5B 0x40 0xAB     */
#endif

/* 0x48 = LZB : Load and Zero-extend Byte*/
	lzb a1 a5               /* FORM_RR     0x48 0xF7               */
	lzb a1 a5 zero d4       /* FORM_RR     0x4B 0xF7 0x00 0x87     */

#if defined(ARCH_yasep32)
/* 0xC8 = LZH : Load and Zero-extend Half-word*/
	lzh d1 d2               /* FORM_RR     0xC8 0xEC               */
	lzh d1 d2 msb0 r5       /* FORM_RR     0xCB 0xEC 0xE0 0x5C     */
#endif

/* 0x08 = MOV : Write imm16/imm20/si4 to dest*/
	mov r4 d3               /* FORM_RR     0x08 0x4A               */
	mov r4 d3 bit0 7        /* FORM_RR     0x0B 0x4A 0x60 0x7A     */
	mov 6 r3                /* FORM_iR     0x0A 0x63               */
	mov 6 r3 nz r5          /* FORM_iR     0x0B 0x63 0x22 0x53     */
	mov 65874 r1            /* FORM_IR     0x09 0x11 0x52 0x01     */

/* 0x38 = MUL8H : Multiply higher byte (unsigned)*/
	mul8h r3 d5             /* FORM_RR     0x38 0x36               */
	mul8h r3 d5 zero a4     /* FORM_RR     0x3B 0x36 0x00 0x96     */
	mul8h 3 a4              /* FORM_iR     0x3A 0x39               */
	mul8h 3 a4 never        /* FORM_iR     0x3B 0x39 0x22 0x09     */
	mul8h 108 pc a1         /* FORM_IRR    0x39 0xF0 0x6C 0x00     */
	mul8h 78 d4             /* FORM_IR     0x39 0x88 0x4E 0x00     */
	mul8h a2 pc r1          /* FORM_RRR    0x3B 0xD0 0x00 0x01     */
	mul8h a2 pc r1 msb1 d3  /* FORM_RRR    0x3B 0xD0 0xC0 0xA1     */
	mul8h 2 a3 a4           /* FORM_iRR    0x3B 0x2B 0x02 0x09     */
	mul8h 2 a3 a4 bit0 5    /* FORM_iRR    0x3B 0x2B 0x62 0x59     */

/* 0x18 = MUL8L : Multiply lower byte (unsigned)*/
	mul8l r3 d5             /* FORM_RR     0x18 0x36               */
	mul8l r3 d5 msb1 d1     /* FORM_RR     0x1B 0x36 0xC0 0xE6     */
	mul8l 5 a3              /* FORM_iR     0x1A 0x5B               */
	mul8l 5 a3 lsb0 d2      /* FORM_iR     0x1B 0x5B 0xA2 0xCB     */
	mul8l 156 d5 r3         /* FORM_IRR    0x19 0x36 0x9C 0x00     */
	mul8l 83 a3             /* FORM_IR     0x19 0xBB 0x53 0x00     */
	mul8l d1 d2 a2          /* FORM_RRR    0x1B 0xEC 0x00 0x0D     */
	mul8l d1 d2 a2 msb1 a3  /* FORM_RRR    0x1B 0xEC 0xC0 0xBD     */
	mul8l 3 d1 r4           /* FORM_iRR    0x1B 0x3E 0x02 0x04     */
	mul8l 3 d1 r4 lsb1 a5   /* FORM_iRR    0x1B 0x3E 0x82 0x74     */

/* 0x58 = MULI : Initialize one multiply LUT entry*/
	muli r2 pc              /* FORM_RR     0x58 0x20               */
	muli 3 d2               /* FORM_iR     0x5A 0x3C               */
	muli 31648 pc           /* FORM_IR     0x59 0x00 0xA0 0x7B     */

/* 0x50 = NAND : Boolean AND with negated output*/
	nand d1 a4              /* FORM_RR     0x50 0xE9               */
	nand d1 a4 neq          /* FORM_RR     0x53 0xE9 0xE0 0x09     */
	nand 3 d4               /* FORM_iR     0x52 0x38               */
	nand 3 d4 lsb1 d3       /* FORM_iR     0x53 0x38 0x82 0xA8     */
	nand 22823 a3 a5        /* FORM_IRR    0x51 0x7B 0x27 0x59     */
	nand 10157 r1           /* FORM_IR     0x51 0x11 0xAD 0x27     */
	nand r3 pc d5           /* FORM_RRR    0x53 0x30 0x00 0x06     */
	nand r3 pc d5 bit1 8    /* FORM_RRR    0x53 0x30 0x40 0x86     */
	nand 5 a5 d5            /* FORM_iRR    0x53 0x57 0x02 0x06     */
	nand 5 a5 d5 carry      /* FORM_iRR    0x53 0x57 0x82 0x06     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x34 = NEG (alias to SUB) : arithmetic negation*/
	neg r4                  /* FORM_R      0x36 0x04               */
	neg r4 bit1 14          /* FORM_R      0x37 0x04 0x42 0xE4     */
	neg r3 a5               /* FORM_RR     0x37 0x03 0x02 0x07     */
	neg r3 a5 lsb0 r5       /* FORM_RR     0x37 0x03 0xA2 0x57     */
#endif

/* 0x00 = NOP : Do nothing*/
	nop                     /* FORM_ALONE  0x00 0x00               */

/* 0xB0 = NOR : Boolean OR with negated output*/
	nor a3 a1               /* FORM_RR     0xB0 0xBF               */
	nor a3 a1 eq            /* FORM_RR     0xB3 0xBF 0xC0 0x0F     */
	nor 3 a2                /* FORM_iR     0xB2 0x3D               */
	nor 3 a2 carry          /* FORM_iR     0xB3 0x3D 0x82 0x0D     */
	nor 11875 a1 d4         /* FORM_IRR    0xB1 0x8F 0x63 0x2E     */
	nor 9212 a4             /* FORM_IR     0xB1 0x99 0xFC 0x23     */
	nor r1 d3 a4            /* FORM_RRR    0xB3 0x1A 0x00 0x09     */
	nor r1 d3 a4 neq        /* FORM_RRR    0xB3 0x1A 0xE0 0x09     */
	nor 3 d3 a4             /* FORM_iRR    0xB3 0x3A 0x02 0x09     */
	nor 3 d3 a4 msb0 a3     /* FORM_iRR    0xB3 0x3A 0xE2 0xB9     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x90 = NOT (alias to ORN) : Boolean negation (alias to ORN)*/
	not d2                  /* FORM_R      0x92 0x0C               */
	not d2 msb0 r5          /* FORM_R      0x93 0x0C 0xE2 0x5C     */
	not d5 pc               /* FORM_RR     0x93 0x06 0x02 0x00     */
	not d5 pc eq            /* FORM_RR     0x93 0x06 0xC2 0x00     */
#endif

/* 0x70 = OR : Boolean OR*/
	or a2 r5                /* FORM_RR     0x70 0xD5               */
	or a2 r5 neq            /* FORM_RR     0x73 0xD5 0xE0 0x05     */
	or 7 a5                 /* FORM_iR     0x72 0x77               */
	or 7 a5 bit0 5          /* FORM_iR     0x73 0x77 0x62 0x57     */
	or 14147 a1 d4          /* FORM_IRR    0x71 0x8F 0x43 0x37     */
	or 408 d5               /* FORM_IR     0x71 0x66 0x98 0x01     */
	or pc r4 d4             /* FORM_RRR    0x73 0x04 0x00 0x08     */
	or pc r4 d4 carry       /* FORM_RRR    0x73 0x04 0x80 0x08     */
	or 1 d2 r4              /* FORM_iRR    0x73 0x1C 0x02 0x04     */
	or 1 d2 r4 no_carry     /* FORM_iRR    0x73 0x1C 0xA2 0x04     */

/* 0x90 = ORN : Boolean OR with one negated input*/
	orn r3 a4               /* FORM_RR     0x90 0x39               */
	orn r3 a4 nz r1         /* FORM_RR     0x93 0x39 0x20 0x19     */
	orn 2 r5                /* FORM_iR     0x92 0x25               */
	orn 2 r5 msb1 a2        /* FORM_iR     0x93 0x25 0xC2 0xD5     */
	orn 30569 a2 d2         /* FORM_IRR    0x91 0xCD 0x69 0x77     */
	orn 21265 pc            /* FORM_IR     0x91 0x00 0x11 0x53     */
	orn a2 d4 r2            /* FORM_RRR    0x93 0xD8 0x00 0x02     */
	orn a2 d4 r2 no_carry   /* FORM_RRR    0x93 0xD8 0xA0 0x02     */
	orn 2 r2 r4             /* FORM_iRR    0x93 0x22 0x02 0x04     */
	orn 2 r2 r4 bit0 13     /* FORM_iRR    0x93 0x22 0x62 0xD4     */

/* 0xA0 = OUT : Send data to I/O on the address bus*/
	out r4 d4               /* FORM_RR     0xA0 0x48               */
	out pc 4                /* FORM_Ri     0xA2 0x40               */
	out r3 770              /* FORM_RI     0xA1 0x03 0x02 0x03     */

/* 0x60 = PUT : Write to the Special Registers space*/
	put a2 d1               /* FORM_RR     0x60 0xDE               */
	put a2 4                /* FORM_Ri     0x62 0x4D               */
	put r4 18839            /* FORM_RI     0x61 0x04 0x97 0x49     */

/* 0x8C = ROL : ROtate Left*/
	rol a1 d4               /* FORM_RR     0x8C 0xF8               */
	rol a1 d4 never         /* FORM_RR     0x8F 0xF8 0x20 0x08     */
	rol 2 r3                /* FORM_iR     0x8E 0x23               */
	rol 2 r3 bit0 11        /* FORM_iR     0x8F 0x23 0x62 0xB3     */
	rol 18 d2 a1            /* FORM_IRR    0x8D 0xFC 0x12 0x00     */
	rol 16 r4               /* FORM_IR     0x8D 0x44 0x10 0x00     */
	rol d3 r4 d5            /* FORM_RRR    0x8F 0xA4 0x00 0x06     */
	rol d3 r4 d5 bit0 13    /* FORM_RRR    0x8F 0xA4 0x60 0xD6     */
	rol 1 a2 d2             /* FORM_iRR    0x8F 0x1D 0x02 0x0C     */
	rol 1 a2 d2 never       /* FORM_iRR    0x8F 0x1D 0x22 0x0C     */

/* 0x6C = ROR : ROtate Right*/
	ror d2 r2               /* FORM_RR     0x6C 0xC2               */
	ror d2 r2 lsb0 d3       /* FORM_RR     0x6F 0xC2 0xA0 0xA2     */
	ror 1 d1                /* FORM_iR     0x6E 0x1E               */
	ror 1 d1 carry          /* FORM_iR     0x6F 0x1E 0x82 0x0E     */
	ror 21 a4 d3            /* FORM_IRR    0x6D 0xA9 0x15 0x00     */
	ror 26 r5               /* FORM_IR     0x6D 0x55 0x1A 0x00     */
	ror r5 d4 r3            /* FORM_RRR    0x6F 0x58 0x00 0x03     */
	ror r5 d4 r3 bit0 7     /* FORM_RRR    0x6F 0x58 0x60 0x73     */
	ror 7 r4 a5             /* FORM_iRR    0x6F 0x74 0x02 0x07     */
	ror 7 r4 a5 zero d5     /* FORM_iRR    0x6F 0x74 0x02 0x67     */

/* 0x2C = SAR : Shift Arithmetic Right*/
	sar a2 d1               /* FORM_RR     0x2C 0xDE               */
	sar a2 d1 msb1 a3       /* FORM_RR     0x2F 0xDE 0xC0 0xBE     */
	sar 3 r4                /* FORM_iR     0x2E 0x34               */
	sar 3 r4 eq             /* FORM_iR     0x2F 0x34 0xC2 0x04     */
	sar 19 r1 r4            /* FORM_IRR    0x2D 0x41 0x13 0x00     */
	sar 18 r2               /* FORM_IR     0x2D 0x22 0x12 0x00     */
	sar d1 a5 a3            /* FORM_RRR    0x2F 0xE7 0x00 0x0B     */
	sar d1 a5 a3 msb0 d4    /* FORM_RRR    0x2F 0xE7 0xE0 0x8B     */
	sar 5 a4 a1             /* FORM_iRR    0x2F 0x59 0x02 0x0F     */
	sar 5 a4 a1 nz d2       /* FORM_iRR    0x2F 0x59 0x22 0xCF     */

/* 0x28 = SB : Store the imm16/si4 Byte*/
	sb d2 a5                /* FORM_RR     0x28 0xC7               */
	sb d2 a5 msb0 a5        /* FORM_RR     0x2B 0xC7 0xE0 0x77     */
	sb 2 d2                 /* FORM_iR     0x2A 0x2C               */
	sb 2 d2 nz a4           /* FORM_iR     0x2B 0x2C 0x22 0x9C     */
	sb 130 r2               /* FORM_IR     0x29 0x22 0x82 0x00     */
	sb r4 r2 d2             /* FORM_RRR    0x2B 0x42 0x00 0x0C     */
	sb r4 r2 d2 nz a3       /* FORM_RRR    0x2B 0x42 0x20 0xBC     */
	sb 4 a1 r3              /* FORM_iRR    0x2B 0x4F 0x02 0x03     */
	sb 4 a1 r3 bit1 12      /* FORM_iRR    0x2B 0x4F 0x42 0xC3     */

#if defined(ARCH_yasep32)
/* 0x88 = SH : Store the imm16/si4 Half-word*/
	sh r4 r3                /* FORM_RR     0x88 0x43               */
	sh r4 r3 msb1 d1        /* FORM_RR     0x8B 0x43 0xC0 0xE3     */
	sh 6 d4                 /* FORM_iR     0x8A 0x68               */
	sh 6 d4 neq             /* FORM_iR     0x8B 0x68 0xE2 0x08     */
	sh 28523 r4 r3          /* FORM_IRR    0x89 0x34 0x6B 0x6F     */
	sh 5853 d5              /* FORM_IR     0x89 0x66 0xDD 0x16     */
	sh d5 a3 d4             /* FORM_RRR    0x8B 0x6B 0x00 0x08     */
	sh d5 a3 d4 nz d4       /* FORM_RRR    0x8B 0x6B 0x20 0x88     */
	sh 4 a1 r2              /* FORM_iRR    0x8B 0x4F 0x02 0x02     */
	sh 4 a1 r2 bit0 15      /* FORM_iRR    0x8B 0x4F 0x62 0xF2     */
#endif

#if defined(ARCH_yasep32)
/* 0xA8 = SHH : Store the imm16/si4 Half-word High*/
	shh a4 r2               /* FORM_RR     0xA8 0x92               */
	shh a4 r2 eq            /* FORM_RR     0xAB 0x92 0xC0 0x02     */
	shh 3 a4                /* FORM_iR     0xAA 0x39               */
	shh 3 a4 lsb0 r5        /* FORM_iR     0xAB 0x39 0xA2 0x59     */
	shh 23404 d5 pc         /* FORM_IRR    0xA9 0x06 0x6C 0x5B     */
	shh 8419 a1             /* FORM_IR     0xA9 0xFF 0xE3 0x20     */
	shh d5 d1 a1            /* FORM_RRR    0xAB 0x6E 0x00 0x0F     */
	shh d5 d1 a1 msb0 r2    /* FORM_RRR    0xAB 0x6E 0xE0 0x2F     */
	shh 2 d2 r3             /* FORM_iRR    0xAB 0x2C 0x02 0x03     */
	shh 2 d2 r3 carry       /* FORM_iRR    0xAB 0x2C 0x82 0x03     */
#endif

/* 0x4C = SHL : SHift logic Left*/
	shl d3 pc               /* FORM_RR     0x4C 0xA0               */
	shl d3 pc neq           /* FORM_RR     0x4F 0xA0 0xE0 0x00     */
	shl 6 r5                /* FORM_iR     0x4E 0x65               */
	shl 6 r5 neq            /* FORM_iR     0x4F 0x65 0xE2 0x05     */
	shl 20 r1 d5            /* FORM_IRR    0x4D 0x61 0x14 0x00     */
	shl 20 r3               /* FORM_IR     0x4D 0x33 0x14 0x00     */
	shl r1 r3 a1            /* FORM_RRR    0x4F 0x13 0x00 0x0F     */
	shl r1 r3 a1 eq         /* FORM_RRR    0x4F 0x13 0xC0 0x0F     */
	shl 1 a3 r2             /* FORM_iRR    0x4F 0x1B 0x02 0x02     */
	shl 1 a3 r2 eq          /* FORM_iRR    0x4F 0x1B 0xC2 0x02     */

/* 0x0C = SHR : SHift logic Right*/
	shr r3 a5               /* FORM_RR     0x0C 0x37               */
	shr r3 a5 bit0 2        /* FORM_RR     0x0F 0x37 0x60 0x27     */
	shr 5 d1                /* FORM_iR     0x0E 0x5E               */
	shr 5 d1 no_carry       /* FORM_iR     0x0F 0x5E 0xA2 0x0E     */
	shr 27 r3 pc            /* FORM_IRR    0x0D 0x03 0x1B 0x00     */
	shr 17 a1               /* FORM_IR     0x0D 0xFF 0x11 0x00     */
	shr r1 r2 d2            /* FORM_RRR    0x0F 0x12 0x00 0x0C     */
	shr r1 r2 d2 no_carry   /* FORM_RRR    0x0F 0x12 0xA0 0x0C     */
	shr 3 a2 d4             /* FORM_iRR    0x0F 0x3D 0x02 0x08     */
	shr 3 a2 d4 no_carry    /* FORM_iRR    0x0F 0x3D 0xA2 0x08     */

/* 0xF4 = SMAX : Set dest to imm16/si4 if snd's value is greater (signed) than imm16/si4*/
	smax d2 d3              /* FORM_RR     0xF4 0xCA               */
	smax d2 d3 bit0 7       /* FORM_RR     0xF7 0xCA 0x60 0x7A     */
	smax 6 pc               /* FORM_iR     0xF6 0x60               */
	smax 6 pc no_carry      /* FORM_iR     0xF7 0x60 0xA2 0x00     */
	smax 12520 d1 d5        /* FORM_IRR    0xF5 0x6E 0xE8 0x30     */
	smax 29200 d5           /* FORM_IR     0xF5 0x66 0x10 0x72     */
	smax a3 r4 r2           /* FORM_RRR    0xF7 0xB4 0x00 0x02     */
	smax a3 r4 r2 msb0 r4   /* FORM_RRR    0xF7 0xB4 0xE0 0x42     */
	smax 4 pc r1            /* FORM_iRR    0xF7 0x40 0x02 0x01     */
	smax 4 pc r1 lsb1 r4    /* FORM_iRR    0xF7 0x40 0x82 0x41     */

/* 0xD4 = SMIN : Set dest to imm16/si4 if snd's value is less (signed) than imm16/si4*/
	smin d5 a5              /* FORM_RR     0xD4 0x67               */
	smin d5 a5 lsb1 r5      /* FORM_RR     0xD7 0x67 0x80 0x57     */
	smin 7 r1               /* FORM_iR     0xD6 0x71               */
	smin 7 r1 eq            /* FORM_iR     0xD7 0x71 0xC2 0x01     */
	smin 7920 d2 a5         /* FORM_IRR    0xD5 0x7C 0xF0 0x1E     */
	smin 28723 d3           /* FORM_IR     0xD5 0xAA 0x33 0x70     */
	smin a4 r4 a1           /* FORM_RRR    0xD7 0x94 0x00 0x0F     */
	smin a4 r4 a1 neq       /* FORM_RRR    0xD7 0x94 0xE0 0x0F     */
	smin 3 d4 d2            /* FORM_iRR    0xD7 0x38 0x02 0x0C     */
	smin 3 d4 d2 msb1 d2    /* FORM_iRR    0xD7 0x38 0xC2 0xCC     */

/* 0x34 = SUB : Substraction*/
	sub a5 r2               /* FORM_RR     0x34 0x72               */
	sub a5 r2 neq           /* FORM_RR     0x37 0x72 0xE0 0x02     */
	sub 3 d1                /* FORM_iR     0x36 0x3E               */
	sub 3 d1 bit0 11        /* FORM_iR     0x37 0x3E 0x62 0xBE     */
	sub 31759 d3 d5         /* FORM_IRR    0x35 0x6A 0x0F 0x7C     */
	sub 12420 r1            /* FORM_IR     0x35 0x11 0x84 0x30     */
	sub d1 a4 d3            /* FORM_RRR    0x37 0xE9 0x00 0x0A     */
	sub d1 a4 d3 zero d5    /* FORM_RRR    0x37 0xE9 0x00 0x6A     */
	sub 1 r4 r1             /* FORM_iRR    0x37 0x14 0x02 0x01     */
	sub 1 r4 r1 eq          /* FORM_iRR    0x37 0x14 0xC2 0x01     */

/* 0xB4 = UMAX : Set dest to imm16/si4 if snd's value is greater (unsigned) than imm16/si4*/
	umax r5 pc              /* FORM_RR     0xB4 0x50               */
	umax r5 pc never        /* FORM_RR     0xB7 0x50 0x20 0x00     */
	umax 3 d1               /* FORM_iR     0xB6 0x3E               */
	umax 3 d1 lsb1 d1       /* FORM_iR     0xB7 0x3E 0x82 0xEE     */
	umax 19994 r3 d2        /* FORM_IRR    0xB5 0xC3 0x1A 0x4E     */
	umax 19766 r2           /* FORM_IR     0xB5 0x22 0x36 0x4D     */
	umax a4 d4 r2           /* FORM_RRR    0xB7 0x98 0x00 0x02     */
	umax a4 d4 r2 lsb1 d5   /* FORM_RRR    0xB7 0x98 0x80 0x62     */
	umax 3 d1 pc            /* FORM_iRR    0xB7 0x3E 0x02 0x00     */
	umax 3 d1 pc never      /* FORM_iRR    0xB7 0x3E 0x22 0x00     */

/* 0x94 = UMIN : Set dest to imm16/si4 if snd's value is less (unsigned) than imm16/si4*/
	umin a4 r2              /* FORM_RR     0x94 0x92               */
	umin a4 r2 lsb1 d1      /* FORM_RR     0x97 0x92 0x80 0xE2     */
	umin 2 r1               /* FORM_iR     0x96 0x21               */
	umin 2 r1 never         /* FORM_iR     0x97 0x21 0x22 0x01     */
	umin 947 r1 a5          /* FORM_IRR    0x95 0x71 0xB3 0x03     */
	umin 26021 r5           /* FORM_IR     0x95 0x55 0xA5 0x65     */
	umin r1 r5 d3           /* FORM_RRR    0x97 0x15 0x00 0x0A     */
	umin r1 r5 d3 msb0 r5   /* FORM_RRR    0x97 0x15 0xE0 0x5A     */
	umin 5 r4 pc            /* FORM_iRR    0x97 0x54 0x02 0x00     */
	umin 5 r4 pc msb1 d3    /* FORM_iRR    0x97 0x54 0xC2 0xA0     */

/* 0xD0 = XOR : Boolean XOR*/
	xor a4 a1               /* FORM_RR     0xD0 0x9F               */
	xor a4 a1 eq            /* FORM_RR     0xD3 0x9F 0xC0 0x0F     */
	xor 7 a2                /* FORM_iR     0xD2 0x7D               */
	xor 7 a2 no_carry       /* FORM_iR     0xD3 0x7D 0xA2 0x0D     */
	xor 29545 a5 a4         /* FORM_IRR    0xD1 0x97 0x69 0x73     */
	xor 24946 d1            /* FORM_IR     0xD1 0xEE 0x72 0x61     */
	xor d1 d3 r2            /* FORM_RRR    0xD3 0xEA 0x00 0x02     */
	xor d1 d3 r2 bit1 12    /* FORM_RRR    0xD3 0xEA 0x40 0xC2     */
	xor 2 a5 a4             /* FORM_iRR    0xD3 0x27 0x02 0x09     */
	xor 2 a5 a4 lsb0 r3     /* FORM_iRR    0xD3 0x27 0xA2 0x39     */

/* 0xF0 = XORN : Boolean XOR with negated output*/
	xorn a1 r2              /* FORM_RR     0xF0 0xF2               */
	xorn a1 r2 carry        /* FORM_RR     0xF3 0xF2 0x80 0x02     */
	xorn 1 r5               /* FORM_iR     0xF2 0x15               */
	xorn 1 r5 msb0 a5       /* FORM_iR     0xF3 0x15 0xE2 0x75     */
	xorn 7051 r3 r5         /* FORM_IRR    0xF1 0x53 0x8B 0x1B     */
	xorn 24822 a1           /* FORM_IR     0xF1 0xFF 0xF6 0x60     */
	xorn d5 d4 r4           /* FORM_RRR    0xF3 0x68 0x00 0x04     */
	xorn d5 d4 r4 msb0 d4   /* FORM_RRR    0xF3 0x68 0xE0 0x84     */
	xorn 2 r5 r2            /* FORM_iRR    0xF3 0x25 0x02 0x02     */
	xorn 2 r5 r2 bit0 0     /* FORM_iRR    0xF3 0x25 0x62 0x02     */

